/*************************************************************************
* Compute Your Share Version 2.0
*
* This program was written for the PalmPilot.  It computes your part of the
* bill when you go out to a resterant.  This is the second generaiton of this
* program.  It is a mixture of code I generated and code generated by 
* Jorg Grohne's VCP 0.98 development tool.  
*
*/

#pragma pack(2)

/*#define DEBUG 		(0)*/
#define TRUE 		(0==0)
#define FALSE 		(0!=0)
#define start 		VCPREDstart
#define YourShareDBType 'Data'
#define VCPCREATORID    'AJP1'

#include 	<Common.h>
#include 	<System/SysAll.h>
#include 	<UI/UIAll.h>
#include 	"yourshare.h"
#include 	"vcpfunct.c"


/* Global Variables */
char YourShareDBName[] = {"YourShareDB"};

/*************************************************************************
*   OpenDatabase - Open the database
*
*************************************************************************/
 int OpenDatabase(void)
{
  char theString[20];
   UInt index ;

/* Open the database */
  VCPDbBeginWork();
  
  if(VCPDbOpenDB(YourShareDBName,  dmModeReadWrite))
  {
    VCPDbCreateDB(YourShareDBName, VCPCREATORID, 'data');
    VCPDbOpenDB(YourShareDBName,  dmModeReadWrite);
 
    theString[0]=0;
    VCPDbInsertRec(&index, theString);
    VCPDbInsertRec(&index, theString);
    VCPDbInsertRec(&index, theString);

  }
  return(0);
}

/*************************************************************************
*   StartApplication - Open the database and load first form
*
*************************************************************************/
 int StartApplication(void)
{
  if( OpenDatabase() ) return(1);
  FrmGotoForm(FRMMAIN);
  
  return(0); /* No error */
}

/*************************************************************************
*   StopApplication - Close the database
*
*************************************************************************/
static void StopApplication(void)
{
  VCPDbCloseDB();
}

/*************************************************************************
*  frmMain_btnCalculateHandler - Compute the tip, total and indevidual 
*                                amount.
*
*************************************************************************/
static int frmMain_btnCalculateHandler(void)
{
  FormPtr form;

  char theBillText[20];
  char theTipText[20];
  char thePeopleText[20];
  char theTotalText[20];
  char thePerPersonText[20];
  char theOtherTipText[20];
  int i;

  float theBill;
  float theTip;
  float thePeople;
  float theTotal;
  float thePerPerson;
  float theOtherTip;

/* Get the value of the fields and controls */
  VCPFldGetText(FLDBILL, theBillText);
  VCPCtlGetLabel(POPTRIGTIP, theTipText);
  VCPCtlGetLabel(POPTRIGPEOPLE, thePeopleText);
  
/* Convert text into numbers */
  theBill    = atof(theBillText);
  theTip     = atof(theTipText);
  thePeople  = atof(thePeopleText);

/* Figure out the bill */
  theOtherTip= theBill * (theTip/100.0);
  theTotal   = theOtherTip + theBill;

  if(0<thePeople)
    thePerPerson = theTotal / thePeople;
  else
    thePerPerson = 0.0;

/* Convert the numbers into strings */
  ftoa(theOtherTipText,theOtherTip);
  ftoa(theTotalText, theTotal);
  ftoa(thePerPersonText, thePerPerson);

/* Put the strings onto the form */
  VCPCtlSetLabel(LBLOTHERTIP, theOtherTipText);
  VCPCtlSetLabel(LBLTOTALBILL, theTotalText);
  VCPCtlSetLabel(LBLPERPERSON, thePerPersonText);

/* Set the focus to the bill field */
  form=FrmGetActiveForm();
  FrmSetFocus(form, FrmGetObjectIndex(form,FLDBILL));

  return(1);  /* handled */
}

/*************************************************************************
*  frmMain_btnClearAllHandler - Clear all of the fields
*
*************************************************************************/
static int frmMain_btnClearAllHandler(void)
{
  char theString[20];


  VCPFldClearText(FLDBILL);
  VCPCtlSetLabel(POPTRIGTIP,   "     ");
  VCPCtlSetLabel(POPTRIGPEOPLE,"     ");
  VCPCtlSetLabel(LBLTOTALBILL, "     ");
  VCPCtlSetLabel(LBLPERPERSON, "     ");
  VCPCtlSetLabel(LBLOTHERTIP,  "     ");

  return(1);  /* handled */
}


/*************************************************************************
*  frmMain_frmOpenEventHandler - Load up the form with data
*                                                                 from the database.
*
*************************************************************************/
static int frmMain_frmOpenEventHandler(void)
{
  char theString[20];
  FormPtr pfrm;

/* Get the stored data from the database and put it on the screen */  
  VCPDbGetRec(0, theString);
  VCPFldSetText(FLDBILL,theString);

  VCPDbGetRec(1, theString);
  VCPCtlSetLabel(POPTRIGTIP,theString);

  VCPDbGetRec(2, theString);
  VCPCtlSetLabel(POPTRIGPEOPLE,theString);

  return(0);
}

/*************************************************************************
*  frmMain_ctrExitEventHandler - Store the user's selections
*
*************************************************************************/
static int frmMain_ctlExitEventHandler(void)
{
  FormPtr form;

  char theString[20];

  VCPFldGetText(FLDBILL,theString);
  VCPDbUpdateRec(0, theString);

  VCPCtlGetLabel(POPTRIGTIP,theString);
  VCPDbUpdateRec(1, theString);

  VCPCtlGetLabel(POPTRIGPEOPLE,theString);
  VCPDbUpdateRec(2, theString);

/* Set the focus to the bill field */
  form=FrmGetActiveForm();
  FrmSetFocus(form, FrmGetObjectIndex(form,FLDBILL));
}



/*************************************************************************
*  frmMain_poptrigTipHandler - Make the tip list pop up
*   POPUPLIST  ID 27 22
*
*************************************************************************/
static int frmMain_poptrigTipHandler(void)
{

  FormPtr formp;
  ListPtr lp;
  char *theString;
  Word theIndex;

  formp=FrmGetActiveForm();
  lp=FrmGetObjectPtr(formp,FrmGetObjectIndex(formp,LISTTIP));
  theIndex = LstPopupList(lp);
  theString = LstGetSelectionText(lp,theIndex);
  VCPCtlSetLabel(POPTRIGTIP,theString);

  return(1);
}

/*************************************************************************
*  frmMain_poptrigPeopleHandler - Make the tip list pop up
*
*************************************************************************/
static int frmMain_poptrigPeopleHandler(void)
{

  FormPtr formp;
  ListPtr lp;
  char *theString;
  Word theIndex;

  formp=FrmGetActiveForm();
  lp=FrmGetObjectPtr(formp,FrmGetObjectIndex(formp,LISTPEOPLE));
  theIndex = LstPopupList(lp);
  theString = LstGetSelectionText(lp,theIndex);
  VCPCtlSetLabel(POPTRIGPEOPLE,theString);

  return(1);
}


/*************************************************************************
*   frmAboutEventHander - About form start handler
*
*************************************************************************/
static Boolean frmMainEventHander(EventPtr event)
{
  FormPtr   form;
  int       handled = 0;

  switch (event->eType) 
  {
    case frmOpenEvent:
      frmMain_frmOpenEventHandler();
      form = FrmGetActiveForm();
      FrmDrawForm(form);
      FrmSetFocus ( form, FrmGetObjectIndex(form, FLDBILL));
      handled = 1;
      break;

    case ctlSelectEvent:
      switch(event->data.ctlEnter.controlID)
      {
        case  BTNCALCULATE:
          handled =frmMain_btnCalculateHandler();
          break;

        case BTNCLEARALL:
          handled =frmMain_btnClearAllHandler();
          break;

        case POPTRIGTIP:
          handled = frmMain_poptrigTipHandler();
          break;
 
       case POPTRIGPEOPLE:
          handled = frmMain_poptrigPeopleHandler();
          break;
      }

    case menuEvent:
      MenuEraseStatus(0);
      switch (event->data.menu.itemID)
      {
        case MEMABOUT:
          FrmGotoForm(FRMABOUT);
          handled = true;
          break;
      }

    case ctlExitEvent:
      handled = frmMain_ctlExitEventHandler();
      break;     
		    
    case nilEvent:
      handled = 1;
      break;
  }
  return handled;
}

/*************************************************************************
*   frmAboutEventHander - About form start handler
*
*************************************************************************/
static Boolean frmAboutEventHander(EventPtr event)
{
  FormPtr   form;
  int       handled = 0;

  switch (event->eType)
  {
    case frmOpenEvent:
      form = FrmGetActiveForm();
      FrmDrawForm(form);
      handled = 1;
      break;
    case ctlSelectEvent: 
      if (event->data.ctlEnter.controlID == BTNOK)
      {
        FrmGotoForm(FRMMAIN);
        handled = 1;
      }
      break; 
    case nilEvent:
      handled = 1;
      break;
  }
  return handled;
}


/*************************************************************************
*  EventLoop - Main event loop
*
*************************************************************************/
static void EventLoop(void)
{
  short err;
  int formID;
  FormPtr form;
  EventType event;

  do
  {
    EvtGetEvent(&event, 200);

    if (SysHandleEvent(&event)) continue;
    if (MenuHandleEvent((void *)0, &event, &err)) continue;

    if (event.eType == frmLoadEvent)
    {
      formID = event.data.frmLoad.formID;
      form = FrmInitForm(formID);
      FrmSetActiveForm(form);
      switch (formID) 
      {  
        case FRMMAIN:
          FrmSetEventHandler(form, (FormEventHandlerPtr) frmMainEventHander);
          break;  
        case FRMABOUT:
          FrmSetEventHandler(form, (FormEventHandlerPtr) frmAboutEventHander);
          break;  
       }
    } 
    FrmDispatchEvent(&event);
    } while(event.eType != appStopEvent);
}

/*************************************************************************
*  PilotMain - Main function
*
*************************************************************************/
DWord  PilotMain (Word cmd, Ptr cmdPBP, Word launchFlags)
{
	int error;
	if (cmd == sysAppLaunchCmdNormalLaunch)
 	{
		error = StartApplication();	// Application start code
		if (error) return error;
		EventLoop();	// Event loop
		StopApplication ();	// Application stop code
	}
	return 0;
}
